#!/usr/bin/python
# -*- coding: UTF-8 -*-
#
# --- [ config.py ] ------------------------------------------------------------
#
# ---   08.07.2014

import tkinter as tk

class Readintervall(tk.LabelFrame):
    def __init__(self, master, column = 0, row = 0,
                        font = ("Courier",10,"bold" )):
        tk.LabelFrame.__init__(self, master, text = "Aktualisierungsintervall")
        self.grid(column = column, columnspan = 2,
                        row = row, padx = 5, pady = 5, sticky = "nsew")

        self.callback_1 = None
        self.callback_2 = None
        self.intervall = tk.IntVar()
        self.intervall.set(10)
        self.next_intervall = tk.StringVar()
        self.update(10)

        tk.Label(self, text = "Intervall in Sek." , width = 17, font = font,
                anchor = "e").grid(column = 0, row = 0, padx= 5, pady = 5, sticky = "w")

        tk.Spinbox(self, font = font, width = 4, textvariable = self.intervall,
                command = self.__changed, from_ = 1, to = 120, state = "readonly").grid(
                column = 1, row = 0, padx = 5, pady = 3, sticky = "ew")

        tk.Button(self, textvariable = self.next_intervall,
                command = self.__messung, font = font, width = 25, anchor ="center").grid(
                column = 3, row = 0, padx= 5, pady = 3, sticky = "ew")


    def set_callback(self, cb1, cb2):
        self.callback_1 = cb1
        self.callback_2 = cb2


    def __changed(self):
        """ Der Spinbutton mit dem Messintervall wurde geändert """
        if self.callback_1 is not None:
            self.callback_1(self.intervall.get())


    def __messung(self):
        """ Der Button mit der Zeitanzeige wurde angeklickt,
            eine Messung ausführen """
        self.bell()
        if self.callback_2 is not None:
            self.callback_2()


    def update(self, t):
        """ Die Anzeige aktualisieren, bei t >= 0 wird die Zeit
            bis zur nächsten Messung ausgegeben,
            bei t < 0 die Aufforderung zur manuellen Messung
        """
        if t >= 0:
            self.next_intervall.set("Aktualisierung in {} S.".format(t))
        else:
            self.next_intervall.set("aktualisieren")


if __name__ == '__main__':
    class App(tk.Tk):
        def __init__(self):
            tk.Tk.__init__(self)
            self.title("Einstellungen")
            Readintervall(self)
            self.mainloop()

    App()

